Bug 986991

Summary: Review Request: rubygem-sprockets-rails - Sprockets Rails integration
Product: [Fedora] Fedora Reporter: Josef Stribny <jstribny>
Component: Package ReviewAssignee: Achilleas Pipinellis <axilleas>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: axilleas, hhorak, notting, package-review
Target Milestone: ---Flags: axilleas: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-08-08 04:24:18 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Josef Stribny 2013-07-22 10:50:29 EDT
Spec URL: http://data-strzibny.rhcloud.com/rubygem-sprockets-rails.spec
SRPM URL: http://data-strzibny.rhcloud.com/rubygem-sprockets-rails-2.0.0-1.fc20.src.rpm
Description: Provides Sprockets implementation for Rails 4.x (and beyond) Asset Pipeline.
Fedora Account System Username: jstribny
Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=5639799
Comment 1 Achilleas Pipinellis 2013-07-29 15:05:49 EDT
I'll take this for a review.
Comment 2 Achilleas Pipinellis 2013-07-31 02:34:55 EDT
Ok, some remarks.

First of all, I would like to see `%build` above `gem build %{gem_name}.gemspec`. I know it doesn't mean much for gems, but I like the consistency :)


Second, I couldn't get it to build locally on mock (rawhide) because of rack's version. In particular:

Error: Package: 1:rubygem-actionpack-3.2.13-2.fc20.noarch (fedora)
    Requires: rubygem(rack) < 1.5
    Available: 1:rubygem-rack-1.5.2-1.fc20.noarch (fedora)
    rubygem(rack) = 1.5.2

It seems in the koji build you provided it installed rack-1.4.5-3 from f19 [0], which is in accordance with actionpack's Requires.

I asked in #devel and I was told that building for rawhide "**might** include some F19 packages, if these packages were last built before F19 branched out of Rawhide (i.e when Rawhide actually was F19)."

As I see it, the only way to build for rawhide is to loosen the rack dependency of actionpack [1].

Nevertheless, I tested it for f19 and it builds fine, rpmlint gives no errors and it installs and loads fine in irb.

How do you want to proceed?

[0] http://kojipkgs.fedoraproject.org//work/tasks/9800/5639800/root.log
[1] http://pkgs.fedoraproject.org/cgit/rubygem-actionpack.git/tree/rubygem-actionpack.spec#n38
Comment 3 Josef Stribny 2013-07-31 06:51:04 EDT
Hi,

it's actually my fault, because I broken up rawhide by updating rack too soon (so now old Rails 3.0 is unfortunately broken and it's not yet replaced by 4.0), I tested this package before it happened which you can see above in the old koji link. I will have to build it without running the tests and enable them after I finish Rails 4.

As for the %build, I changed it.

Spec URL: http://data-strzibny.rhcloud.com/rubygem-sprockets-rails.spec
SRPM URL: http://kojipkgs.fedoraproject.org//work/tasks/3173/5683173/rubygem-sprockets-rails-2.0.0-2.fc20.src.rpm
Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=5683171

Thanks.
Comment 4 Achilleas Pipinellis 2013-07-31 13:55:08 EDT
Ok, now it makes sense. But again, actionpack should be updated first, no? 

Without a version bump (3.2.13->4.0.0), sprockets-rails still Requires rack <= 1.5 and although it is built fine it cannot be installed. 

Is the update of actionpack scheduled anytime soon? If yes, I guess we can push sprockets-rails to rawhide now. Let me know if that's the case, I have the review ready.
Comment 5 Josef Stribny 2013-08-01 03:51:54 EDT
Yes, it is, and I will try try to wait to build all those dependent packages like this one after I checked that Rails packages works for me locally. I just need to have them prepared. After that, it should be only matter of update of deps and then Rails.
Comment 6 Achilleas Pipinellis 2013-08-02 03:19:14 EDT
After above explanation, package is APPROVED.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[-]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     sprockets-rails-doc
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 6 files have unknown license. Detailed output of
     licensecheck in /home/axil/review/986991-rubygem-sprockets-
     rails/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Test run failed
[x]: Packages must not store files under /srv, /opt or /usr/local
     Note: Test run failed
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

Ruby:
[x]: Specfile should use macros from rubygem-devel package.
     Note: The specfile doesn't use these macros: %doc %{gem_docdir},
     %{gem_spec}, %exclude %{gem_cache}, %{gem_libdir}
[?]: Test suite of the library should be run.
[x]: Gem package should exclude cached Gem.

===== EXTRA items =====

Generic:
[?]: Rpmlint is run on all installed packages.
     Note: Mock build failed
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Test run failed
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.1.32 starting...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Mock Version: 1.1.32
INFO: Mock Version: 1.1.32
Start: lock buildroot
INFO: installing package(s): /home/axil/review/986991-rubygem-sprockets-rails/results/rubygem-sprockets-rails-2.0.0-2.fc20.noarch.rpm /home/axil/review/986991-rubygem-sprockets-rails/results/rubygem-sprockets-rails-doc-2.0.0-2.fc20.noarch.rpm
ERROR: Command failed: 
 # ['/usr/bin/yum', '--installroot', '/var/lib/mock/fedora-rawhide-x86_64/root/', 'install', '/home/axil/review/986991-rubygem-sprockets-rails/results/rubygem-sprockets-rails-2.0.0-2.fc20.noarch.rpm', '/home/axil/review/986991-rubygem-sprockets-rails/results/rubygem-sprockets-rails-doc-2.0.0-2.fc20.noarch.rpm', '--setopt=tsflags=nocontexts']
Error: Package: 1:rubygem-actionpack-3.2.13-2.fc20.noarch (fedora)
           Requires: rubygem(rack) < 1.5
           Installing: 1:rubygem-rack-1.5.2-1.fc20.noarch (fedora)
               rubygem(rack) = 1.5.2
Error: Package: 1:rubygem-actionpack-3.2.13-2.fc20.noarch (fedora)
           Requires: rubygem(rack) < 1.5
           Available: 1:rubygem-rack-1.5.2-1.fc20.noarch (fedora)
               rubygem(rack) = 1.5.2
 You could try using --skip-broken to work around the problem
 You could try running: rpm -Va --nofiles --nodigest



Rpmlint
-------
Checking: rubygem-sprockets-rails-2.0.0-2.fc20.noarch.rpm
          rubygem-sprockets-rails-doc-2.0.0-2.fc20.noarch.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Requires
--------
rubygem-sprockets-rails-doc (rpmlib, GLIBC filtered):
    rubygem-sprockets-rails

rubygem-sprockets-rails (rpmlib, GLIBC filtered):
    ruby(release)
    ruby(rubygems)
    rubygem(actionpack)
    rubygem(activesupport)
    rubygem(sprockets)



Provides
--------
rubygem-sprockets-rails-doc:
    rubygem-sprockets-rails-doc

rubygem-sprockets-rails:
    rubygem(sprockets-rails)
    rubygem-sprockets-rails



Source checksums
----------------
https://rubygems.org/gems/sprockets-rails-2.0.0.gem :
  CHECKSUM(SHA256) this package     : 1d88f523c36d56edf67561fe4c1abd032565bed58f5723898f6c877e3c051c19
  CHECKSUM(SHA256) upstream package : 1d88f523c36d56edf67561fe4c1abd032565bed58f5723898f6c877e3c051c19


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 986991
Comment 7 Josef Stribny 2013-08-02 03:28:45 EDT
Thank you.


New Package SCM Request
=======================
Package Name: rubygem-sprockets-rails
Short Description: Sprockets Rails integration
Owners: jstribny
Branches:
InitialCC:
Comment 8 Jon Ciesla 2013-08-02 07:59:09 EDT
Git done (by process-git-requests).